/*
    DFT++ is a density functional package developed by the research group
    of Professor Tomas Arias

    Copyright 1996-2003 Sohrab Ismail-Beigi

    This file is part of DFT++.

    DFT++ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    DFT++ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DFT++; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Please see the file CREDITS for a list of authors.

    For academic users, we request that publications using results obtained with
    this software reference

    "New algebraic formulation of density functional calculation," by Sohrab Ismail-Beigi
    and T.A. Arias, Computer Physics Communications 128:1-2, 1-45 (June 2000).

    and, if using the wavelet basis, further reference

    "Multiresolution analysis of electronic structure: semicardinal and wavelet bases,"
    T.A. Arias, Reviews of Modern Physics 71:1, 267-311 (January 1999).

    and 

    "Robust ab initio calculation of condensed matter: transparent convergence through
    semicardinal multiresolution analysis,'' I.P. Daykov, T.A. Arias, and
    Torkel D. Engeness, Physical Review Letters, 90:21, 216402 (May 2003).

    For your convenience, preprints of the above articles may be obtained from
    http://arXiv.org/abs/cond-mat/9909130, 9805262, and 0204411, respectively.
*/

/*
 * Gabor Csanyi 8/1/2001
 *
 * the ComplexArray class holds a simple array of complex numbers
 *
 */

#ifndef DFT_COMPLEX_ARRAY_H
#define DFT_COMPLEX_ARRAY_H

class ComplexArray
{
 public:
  int ndata;  // number of data elements;
  const static int datasize = sizeof(complex);
  complex *d; // data array

  ComplexArray(int ndata);
  ComplexArray();
  void init(int);
  void free();

  // get and release scratch space
  void get_temp(int);
  void release_temp();

  void operator=(const ComplexArray &cd);
  inline void operator=(complex c);
  ComplexArray operator+(const ComplexArray &cd);
  void operator+=(const ComplexArray &cd);
  ComplexArray operator-(const ComplexArray &cd);
  void operator-=(const ComplexArray &cd);
  ComplexArray operator*(const real r);
  ComplexArray operator*(const complex c);
  void operator*=(const real r);
  void operator*=(const complex c);

  void operator*=(const ComplexArray &in);
  
  void zero_out(void);
  void negate(void);
  void randomize(void);//uniform distribution
    
  void write(char *fname);
  void write(FILE *fp);
  void writea(char *fname);
  void read(char *fname);
  void print();
};

ComplexArray operator*(real r,const ComplexArray &cd);
ComplexArray operator*(complex c,const ComplexArray &cd);

real abs2(const ComplexArray &cd);

void
add_scale_abs2(const complex &c, const ComplexArray & in,
               ComplexArray &out);

complex dot(const ComplexArray &cd1,const ComplexArray &cd2);
void scale_accumulate(real r,const ComplexArray &cd1, ComplexArray &cd2);
void scale_accumulate(complex c,const ComplexArray &cd1, ComplexArray &cd2);
void scaled_sum(real r1, const ComplexArray &cd1,
                real r2, const ComplexArray &cd2,
                ComplexArray &cd3);

/*void scaled_sum(real r1,ComplexArray &cd1,
                real r2, ComplexArray &cd2,
                ComplexArray &cd3);
*/
void point_mult(ComplexArray &a1, ComplexArray &in2, ComplexArray &out);


#endif // DFT_COMPLEX_ARRAY_H
